Package org.apache.commons.collections4.bidimap

# Class AbstractSortedBidiMapDecorator<K,V>

java.lang.Object
org.apache.commons.collections4.map.AbstractIterableMap<K,V>
org.apache.commons.collections4.map.AbstractMapDecorator<K,V>
org.apache.commons.collections4.bidimap.AbstractBidiMapDecorator<K,V>
org.apache.commons.collections4.bidimap.AbstractOrderedBidiMapDecorator<K,V>
org.apache.commons.collections4.bidimap.AbstractSortedBidiMapDecorator<K,V>

Type Parameters:
  `K` - the type of the keys in this map
  `V` - the type of the values in this map

All Implemented Interfaces:
  `Map<K,V>`, `SortedMap<K,V>`, `BidiMap<K,V>`, `Get<K,V>`, `IterableGet<K,V>`, `IterableMap<K,V>`, `OrderedBidiMap<K,V>`, `OrderedMap<K,V>`, `Put<K,V>`, `SortedBidiMap<K,V>`

Direct Known Subclasses:
  `UnmodifiableSortedBidiMap`

public abstract class AbstractSortedBidiMapDecorator<K,V> extends AbstractOrderedBidiMapDecorator<K,V> implements SortedBidiMap<K,V>
Provides a base decorator that enables additional functionality to be added to a SortedBidiMap via decoration.

Methods are forwarded directly to the decorated map.

This implementation does not perform any special processing with the map views. Instead it simply returns the inverse from the wrapped map. This may be undesirable, for example if you are trying to write a validating implementation it would provide a loophole around the validation. But, you might want that loophole, so this class is kept simple.

Since:
  3.0

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface java.util.Map

  `Map.Entry<K extends Object,V extends Object>`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractSortedBidiMapDecorator(SortedBidiMap<K,V> map)`
  Constructor that wraps (not copies).

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Comparator<? super K>`
  `comparator()`
  `protected SortedBidiMap<K,V>`
  `decorated()`
  Gets the map being decorated.
  `SortedMap<K,V>`
  `headMap(K toKey)`
  `SortedBidiMap<V,K>`
  `inverseBidiMap()`
  Gets a view of this map where the keys and values are reversed.
  `SortedMap<K,V>`
  `subMap(K fromKey, K toKey)`
  `SortedMap<K,V>`
  `tailMap(K fromKey)`
  `Comparator<? super V>`
  `valueComparator()`
  Gets the comparator used for the values in the value-to-key map aspect.

  ### Methods inherited from class org.apache.commons.collections4.bidimap.AbstractOrderedBidiMapDecorator

  `firstKey, lastKey, mapIterator, nextKey, previousKey`

  ### Methods inherited from class org.apache.commons.collections4.bidimap.AbstractBidiMapDecorator

  `getKey, removeValue, values`

  ### Methods inherited from class org.apache.commons.collections4.map.AbstractMapDecorator

  `clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, size, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.apache.commons.collections4.BidiMap

  `getKey, put, removeValue, values`

  ### Methods inherited from interface org.apache.commons.collections4.Get

  `containsKey, containsValue, entrySet, get, isEmpty, keySet, remove, size, values`

  ### Methods inherited from interface java.util.Map

  `clear, compute, computeIfAbsent, computeIfPresent, containsKey, containsValue, equals, forEach, get, getOrDefault, hashCode, isEmpty, merge, putAll, putIfAbsent, remove, remove, replace, replace, replaceAll, size`

  ### Methods inherited from interface org.apache.commons.collections4.OrderedMap

  `firstKey, lastKey, mapIterator, nextKey, previousKey`

  ### Methods inherited from interface org.apache.commons.collections4.Put

  `clear, put, putAll`

  ### Methods inherited from interface java.util.SortedMap

  `entrySet, firstKey, keySet, lastKey, values`

- ## Constructor Details

  - ### AbstractSortedBidiMapDecorator

    public AbstractSortedBidiMapDecorator(SortedBidiMap<K,V> map)
    Constructor that wraps (not copies).
    Parameters:
      `map` - the map to decorate, must not be null
    Throws:
      `NullPointerException` - if the collection is null

- ## Method Details

  - ### comparator

    public Comparator<? super K> comparator()
    Specified by:
      `comparator` in interface `SortedMap<K,V>`

  - ### decorated

    protected SortedBidiMap<K,V> decorated()
    Gets the map being decorated.
    Overrides:
      `decorated` in class `AbstractOrderedBidiMapDecorator<K,V>`
    Returns:
      the decorated map

  - ### headMap

    public SortedMap<K,V> headMap(K toKey)
    Specified by:
      `headMap` in interface `SortedMap<K,V>`

  - ### inverseBidiMap

    public SortedBidiMap<V,K> inverseBidiMap()
    Description copied from interface: `BidiMap`
    Gets a view of this map where the keys and values are reversed.

    Changes to one map will be visible in the other and vice versa. This enables both directions of the map to be accessed as a `Map`.

    Implementations should seek to avoid creating a new object every time this method is called. See `AbstractMap.values()` etc. Calling this method on the inverse map should return the original.

    Specified by:
      `inverseBidiMap` in interface `BidiMap<K,V>`
    Specified by:
      `inverseBidiMap` in interface `OrderedBidiMap<K,V>`
    Specified by:
      `inverseBidiMap` in interface `SortedBidiMap<K,V>`
    Overrides:
      `inverseBidiMap` in class `AbstractOrderedBidiMapDecorator<K,V>`
    Returns:
      an inverted bidirectional map

  - ### subMap

    public SortedMap<K,V> subMap(K fromKey, K toKey)
    Specified by:
      `subMap` in interface `SortedMap<K,V>`

  - ### tailMap

    public SortedMap<K,V> tailMap(K fromKey)
    Specified by:
      `tailMap` in interface `SortedMap<K,V>`

  - ### valueComparator

    public Comparator<? super V> valueComparator()
    Description copied from interface: `SortedBidiMap`
    Gets the comparator used for the values in the value-to-key map aspect.
    Specified by:
      `valueComparator` in interface `SortedBidiMap<K,V>`
    Returns:
      Comparator<? super V>